public class ListaChar{
	private NodoChar head;
	private int size;


	public ListaChar(String s){
		if(s==null || s.length()==0){
			this.head=null;
			this.size=0;
		}else{
			this.head=new NodoChar(s.charAt(0),null);
			NodoChar corrente=this.head;
			for(int i=1;i<s.length();i++){
				NodoChar n=new NodoChar(s.charAt(i),null);
				corrente.setNext(n);
				corrente=n;
			}
			this.size=s.length();
		}
	}

	public int[] contaOccorenze(char[]caratteri){
		int[] occorrenze=new int[caratteri.length];

		for(int i=0;i<caratteri.length;i++){
			NodoChar corrente=this.head;
			while(corrente!=null){
				char ch=corrente.getInfo();
				if(ch==caratteri[i])
					occorrenze[i]++;
				corrente=corrente.getNext();
			}
		}

		return occorrenze;
	}

	public int compareTo(ListaChar l){
		int confronto=0;

		NodoChar curr1=this.head;
		NodoChar curr2=l.head;


		while(curr1!=null && curr2!=null && confronto==0){
			char ch1=curr1.getInfo();
			char ch2=curr2.getInfo();
			if(ch1<ch2)
				confronto=-1;
			else if(ch1>ch2)
				confronto=1;
			curr1=curr1.getNext();
			curr2=curr2.getNext();
		}

		if(confronto==0){
			if(curr1!=null)
				confronto=1;
			if(curr2!=null)
				confronto=-1;
		}

		return confronto;
	}

	public String toString(){
		String str="(";
		NodoChar corrente=this.head;

		while(corrente!=null){
			str+=corrente.getInfo();
			if(corrente.getNext()!=null)
				str+=",";
			corrente=corrente.getNext();
		}

		str+=")";

		return str;
	}

}












