public class TemperatureMensili {

	private String[] citta;
	private double[][] temperature;

	/* Costruisce una tabella le cui città e temperature sono passati come parametro.
	Si assume che citta e temperature abbiano lo stesso numero di righe*/
	public TemperatureMensili (String[] citta, double[][] temperature){
		this.citta=new String[citta.length];
		for(int i=0;i<citta.length;i++)
			this.citta[i]=citta[i];

		this.temperature=new double[temperature.length][temperature[0].length];
		for(int i=0;i<temperature.length;i++)
			for(int j=0;j<temperature[i].length;j++)
				this.temperature[i][j]=temperature[i][j];
	}

	/* Restituisce il nome della città i-esima */
	public String citta(int i){
		return this.citta[i];
	}

	/* Restituisce un array il cui elemento i-esimo è la temperatura media annua della città i-esima. Tale voto è calcolato come la media delle temperature mensili in quella città. */
	public double[] temperatureMedieAnnuePerCitta(){
		double[] medie=new double[this.citta.length];

		for(int i=0;i<medie.length;i++){
			medie[i]=0.0;
			for(int j=0;j<temperature[0].length;j++)
				medie[i]+=temperature[i][j];
			medie[i]=medie[i]/temperature[0].length;
		}

		return medie;
	}

	/* Restituisce un array di dimensione 12. L'elemento i-esimo di tale array è il nomedella città più calda nel mese i-esimo (con Gennaio=0, Febbraio=1, ecc.) */
	public String[] cittaPiuCaldaPerMese(){
		String[] cittaCalde=new String[12];
		for(int j=0;j<temperature[0].length;j++){
			int imax=0;
			for(int i=1;i<temperature.length;i++){
				if(temperature[i][j]>temperature[imax][j])
					imax=i;
			}
			cittaCalde[j]=citta[imax];
		}

		return cittaCalde;

	}

	/* Restituisce un rappresentazione testuale della tabella */
	public String toString(){
		String s="";

		for(int i=0;i<temperature.length;i++){
			s+=citta[i]+"\t";
			for(int j=0;j<temperature[i].length;j++)
				s+=this.temperature[i][j]+"\t";
			s+="\n";
		}

		return s;
	}
}
