public class ListaEsame {

	private String[] iscritti;
	private int count;

	/* Costruisce una lista di iscrizione in cui il massimo numero di iscritti possibili è max*/
	public ListaEsame (int max){
		iscritti=new String[max];
		count=0;
	}

/* Aggiunge lo studente nome alla lista. La lista deve essere mantenuta ordinata alfabeticamente. Il metodo restituisce true se l'aggiunta è avvenuta con successo, restituisce false nel caso in cui l'inserimento non possa avvenire perché il numero massimo di iscritti è già stato raggiunto. */
	public boolean aggiungiIscritto(String nome){
		boolean inserito=false;
		if(count<iscritti.length){
			int index=0;
			for(int i=0;i<count;i++){
				if(nome.compareTo(iscritti[i])>0)
					index++;
			}

			for(int i=count;i>index;i--){
				iscritti[i]=iscritti[i-1];
			}

			iscritti[index]=nome;
			count++;
			inserito=true;
		}
		return inserito;
	}

	/* Rimuove lo studente nome dalla lista. Restituisce true se la cancellazione è avvenuta con successo, restituisce false se la rimozione non è avvenuta perché lo studente nome non è iscritto all'esame */
	public boolean rimuoviIscritto(String nome){
		boolean rimosso=false;
		int index=-1;
		for(int i=0;i<count;i++){
			if(nome.equals(iscritti[i]))
				index=i;
		}
		if(index>-1){
			for(int i=index;i<count-1;i++){
				iscritti[i]=iscritti[i+1];
			}

			iscritti[count-1]=null;
			count--;
			rimosso=true;
		}
		return rimosso;
	}

	/* Restituisce un rappresentazione testuale della lista */
	public String toString(){
		String s="";
		for(int i=0;i<count;i++){
			s+=iscritti[i]+"\n";
		}
		return s;
	}
}
