public class ListaInteri {

	private NodoInteri head;	// riferimento al nodo di testa
	private int size;			// lunghezza della lista

	/* Crea una lista vuota. */
	public ListaInteri(){
		this.head = null;
		this.size = 0;
	}

	/* Aggiunge l'intero n passato come parametro in coda alla lista. */
	public void aggiungi(int n){
		if(this.size == 0){
			this.head=new NodoInteri(n,null);
		}else{
			NodoInteri e=this.head;
			while(e.getNext()!=null)
				e=e.getNext();
			e.setNext(new NodoInteri(n,null));
		}
		this.size++;
	}


	/* Restituisce l'intero memorizzato nella posizione index della lista (0 <= index < size)  */
	public int leggiElemento(int index){
		NodoInteri e=this.head;
		for(int i=0; i<index; i++)
			e=e.getNext();
		return e.getInfo();
	}

	/* Rimuove dalla lista eventuali elementi duplicati. Cio, dopo l'invocazione di tale metodo la lista 	conterr tutti e soli gli elementi distinti che erano contenuti nella lista prima dell'invocazione. */
	public void eliminaDuplicati(){
		NodoInteri e=this.head;
		NodoInteri prev=null;

		while(e!=null){
			NodoInteri e1=e.getNext();
			while(e1!=null && e1.getInfo()!=e.getInfo()){
				e1=e1.getNext();
			}

			if(e1!=null){
				if(prev==null)
					this.head=e.getNext();
				else
					prev.setNext(e.getNext());
				size--;
			}else{
				prev = e;
			}

			e = e.getNext();
		}
	}



	/* Restituisce la lunghezza della lista*/
	public int size(){
		return size;
	}

	/* Restituisce una rappresentazione testuale della lista */
	public String toString(){
		String s="(";
		NodoInteri e=this.head;
		while(e!=null){
			s+=e.getInfo();
			if(e.getNext()!=null){
				s+=",";
			}
			e=e.getNext();
		}
		s+=")";
		return s;
	}
}
