public class ListaInt {

	private NodoInt head;
	private int size;

	/* Crea una lista vuota. */
	public ListaInt(){
		this.head=null;
		this.size=0;

	}

	/* Aggiunge in coda alla lista l'intero n passato come parametro */
	public void aggiungi(int n){
		if(this.size==0)
			this.head=new NodoInt(n,null);
		else{
			NodoInt corrente=this.head;
			while(corrente.getNext()!=null)
				corrente=corrente.getNext();
			corrente.setNext(new NodoInt(n,null));
		}
		this.size++;
	}

	/* Restituisce true se l’intero n è contenuto nella lista su cui è invocato il metodo */
	public boolean cerca(int n){
		boolean trovato=false;
		NodoInt corrente=this.head;

		while(!trovato && corrente!=null){
			if(corrente.getInfo()==n)
				trovato=true;
			corrente=corrente.getNext();
		}

		return trovato;
	}

    /* Restituisce una lista che contiene soltanto gli elementi che sono presenti sia nella lista l passata come parametro che nella lista su cui il metodo è invocato (this). */
	public ListaInt estraiElementiComuni(ListaInt l){
		ListaInt risultato=new ListaInt();
		NodoInt corrente=this.head;

		while(corrente!=null){
			int n=corrente.getInfo();
			if(l.cerca(n))
				risultato.aggiungi(n);
			corrente=corrente.getNext();
		}

		return risultato;
	}

	/* Restituisce una rappresentazione testuale della lista */
	public String toString(){
		String s="(";

		NodoInt corrente=this.head;
		while(corrente!=null){
			s+=corrente.getInfo();
			if(corrente.getNext()!=null)
				s+=",";
			corrente=corrente.getNext();
		}
		s+=")";

		return s;

	}
}
