public class Matrix {

	private int[][] mat;

	/* crea un oggetto Matrix il cui contenuto è rappresentato dalla matrice mat. */
	public Matrix(int[][] mat){
		this.mat=new int[mat.length][mat[0].length];

		for(int i=0;i<this.mat.length;i++)
			for(int j=0;j<this.mat.length;j++)
				this.mat[i][j]=mat[i][j];
	}

	/* Dato un numero di diagonale, restituisce la somma degli elementi di quella diagonale. Se il numero i non è un numero di diagonale valido, il metodo restituisce -1  */
	public int valoreDiagonale(int i){
		int n=this.mat.length;
		int val=0;

		if(i>=-n+1 && i<=0){
			int a=-i;
			int b=0;

			int j=0;
			while(a+j<this.mat.length){
				val+=this.mat[a+j][b+j];
				j++;
			}

		}else if(i>=1 && i<=n-1){
			int a=0;
			int b=i;

			int j=0;
			while(b+j<this.mat.length){
				val+=this.mat[a+j][b+j];
				j++;
			}

		}

		return val;
	}

	/* Restituisce un array di interi che contiene tutti i numeri per cui la diagonale dell’oggetto su cui il metodo è invocato (this) è uguale alla corrispondente diagonale dell’oggetto m. Se i due oggetti non hanno diagonali uguali viene restituito un array vuoto. Se this e m hanno dimensioni diverse viene restituito null*/
	public int[] diagonaliConValoriUguali(Matrix m){
		int[] result;
		if(this.mat.length!=m.mat.length)
			result=null;
		else{
			int n=this.mat.length;
			int[] tmp=new int[2*n-1];
			int count=0;

			for(int i=-n+1;i<=n-1;i++){
				if(this.valoreDiagonale(i)==m.valoreDiagonale(i))
					tmp[count++]=i;
			}

			result=new int[count];
			for(int i=0;i<count;i++){
				result[i]=tmp[i];
			}

		}

		return result;

	}

	/* Restituisce una rappresentazione testuale della matrice */
	public String toString(){
		String s="";
		for(int i=0;i<this.mat.length;i++){
			for(int j=0;j<this.mat[i].length;j++)
				s+=this.mat[i][j]+" ";
			s+="\n";
		}

		return s;
	}
}
