public class Matrice {

	private int[][] mat;

	/* crea un oggetto Matrice il cui contenuto è rappresentato dalla matrice mat. */
	public Matrice(int[][] mat){
		this.mat=new int[mat.length][mat[0].length];

		for(int i=0;i<this.mat.length;i++)
			for(int j=0;j<this.mat[i].length;j++)
				this.mat[i][j]=mat[i][j];
	}

	/* Dato gli indici di due celle (i,j) e (h,k) calcola il valore del cammino rettilineo da (i,j) a (h,k). Si può assumere che gli indici i, j, h e k sono indici validi  */
	public int valorePercorsoRettilineo(int i, int j, int h, int k){
		int valore=0;

		if(k>=j){
			for(int l=j;l<=k;l++)
				valore+=this.mat[i][l];
		}else{
			for(int l=j;l>=k;l--)
				valore+=this.mat[i][l];
		}

		if(h>=i){
			for(int l=i+1;l<=h;l++)
				valore+=this.mat[l][k];
		}else{
			for(int l=i-1;l>=h;l--)
				valore+=this.mat[l][k];
		}

		return valore;
	}

	/* Individua la coppia di celle (i,j) e (h,k) per le quali il percorso rettilineo ha valore massimo. Le due coppie di indici vengono restituite sotto forma di un array bidimensionale di interi di dimensione 2? 2, in cui l’elemento (0,0) contiene l’indice i, l’elemento (0,1) contiene l’indice j, l’elemento (1,0) contiene l’indice h e l’elemento (1,1) contiene l’indice k */
	public int[][] percorsoRettilineoMassimo(){

		int[][] res=new int[2][2];
		int valore=this.mat[0][0];

		res[0][0]=0;
		res[0][1]=0;
		res[1][0]=0;
		res[1][1]=0;

		for(int i=0;i<this.mat.length;i++)
			for(int j=0;j<this.mat[i].length;j++)
				for(int h=0;h<this.mat.length;h++)
					for(int k=0;k<this.mat[i].length;k++){
						int v=valorePercorsoRettilineo(i,j,h,k);
						if(v>valore){
							valore=v;
							res[0][0]=i;
							res[0][1]=j;
							res[1][0]=h;
							res[1][1]=k;
						}

					}
		return res;
	}

	/* Restituisce una rappresentazione testuale della matrice */
	public String toString(){

		String s="";
		for(int i=0;i<this.mat.length;i++){
			for(int j=0;j<this.mat[i].length;j++)
				s+=this.mat[i][j]+" ";
			s+="\n";
		}

		return s;
	}
}
