public class SequenzaDiStringheBinarie {

	private String[] seq;

	/* crea un oggetto SequenzaDiStringheBinarie il cui contenuto è rappresentato dall’array seq. Si assuma che tutte le stringhe di seq, siano effettivamente stringhe binarie. */
	public SequenzaDiStringheBinarie (String[] seq){
		this.seq=new String[seq.length];

		for(int i=0;i<seq.length;i++)
			this.seq[i]=seq[i];
	}

	/* Dato un indice i restituisce il valore numerico rappresentato dalla stringa binaria in posizione i se interpretata come un numero binario. Si assuma che i sia un indice valido.  */
	public int valoreStringa(int i){
		String s=this.seq[i];
		int n=s.length();
		int valore=0;
		for(int j=0;j<n;j++){
			if(s.charAt(j)=='1')
				valore+=Math.pow(2,n-1-j);
		}
		//codice alternativo (ma più criptico)
		//for(int j=0;j<n;j++){
		//		valore=2*valore;
		//		if(s.charAt(j)=='1')
		//			valore+=1;
		//}
		return valore;
	}

/* Dato un intero k restituisce gli indici delle stringhe di seq il cui valore (se interpretate come numeri binari) è superiore a k */
	public int[] elementiSopraSoglia(int k){
		int n=0;
		for(int i=0;i<this.seq.length;i++)
			if(valoreStringa(i)>k)
				n++;

		int[] indici=new int[n];

		int j=0;
		for(int i=0;i<this.seq.length;i++)
			if(valoreStringa(i)>k){
				indici[j]=i;
				j++;
			}

		return indici;
	}

/* Restituisce una rappresentazione testuale della sequenza di stringhe. Per ogni elemento della sequenza va mostrata la stringa binaria e, tra parentesi, il valore numerico della stringa (se interpretata come numero binario) */
	public String toString(){
		String s="";
		for(int i=0;i<seq.length;i++)
			s+=this.seq[i]+" ("+valoreStringa(i)+")\n";
		return s;
	}
}
