public class RisultatiConcorso {

	private String[] nomi;
	private int[][]punteggi;

	/* Costruisce una tabella i cui nomi e punteggi sono passati come parametro.
	Si assume che nomi e voti abbiano lo stesso numero di righe*/
	public RisultatiConcorso (String[] nomi, int[][] punteggi){
		this.nomi=new String[nomi.length];

		for(int i=0;i<this.nomi.length;i++)
			this.nomi[i]=nomi[i];

		this.punteggi=new int[punteggi.length][punteggi[0].length];

		for(int i=0;i<this.punteggi.length;i++)
			for(int j=0;j<this.punteggi[i].length;j++)
				this.punteggi[i][j]=punteggi[i][j];
	}

	/* Restituisce i nomi dei candidati */
	public String[] nomi(){
		String[] res=new String[this.nomi.length];

		for(int i=0;i<this.nomi.length;i++)
			res[i]=this.nomi[i];

		return res;
	}

	/* Restituisce il numero di prove */
	public int numProve(){
		return this.punteggi[0].length;
	}

	/* Restituisce un array il cui elemento i-esimo è il punteggio finale conseguito dal candidato i-esimo. Tale voto è calcolato come la somma dei punteggi riportati dal candidato nelle varie prove. */
	public int[] punteggiCandidati(){
		int[] finali=new int[this.nomi.length];

		for(int i=0;i<finali.length;i++){
			finali[i]=0;
			for(int j=0;j<this.punteggi[i].length;j++)
				finali[i]+=this.punteggi[i][j];
		}

		return finali;
	}

	/* Riceve come parametro un indice i e restituisce un array di interi contenenete i punteggi ottenuti dai vari candidati nella prova i-esima. Se i non è un indice valido restituisce null. */
	public int[] punteggiPerProva(int i){
		int[] voti;
		if(i<0 || i>this.punteggi[0].length)
			voti=null;
		else{
			voti=new int[this.nomi.length];
			for(int j=0;j<this.punteggi.length;j++)
				voti[j]=this.punteggi[j][i];

		}
		return voti;
	}

}
